"""
runs all the scripts
"""
import wedding
import wedding_orig
import wedding_gurobi
import wedding_orig_gurobi
import wedding_dip
import wedding_dip_solver

OUTPUT_FILE = 'results.csv'

all_guests = 'A B C D E F G H I J K L M N O P Q R S T U'.split()
max_table_size = 4

with open(OUTPUT_FILE, 'w') as out_file:
    out_file.write('last_guest,wedding_gen_time,wedding_time,wedding_orig_time,wedding_gurobi_gen_time,wedding_gurobi_time,wedding_gurobi_orig_time,wedding_dip_time,wedding_dip_solver_time,obj\n')

##for i in range(6, len(all_guests) + 1):
##for i in range(6, 12):
for i in range(20, len(all_guests) + 1):
    guests = all_guests[:i]
    max_tables = len(guests)//max_table_size +1

    if len(guests) < 21:    
        wedding_gen_time, wedding_time, wedding_obj,_,_ = wedding.solve_problem(
                                                guests, max_table_size, max_tables)
    else:
        wedding_time = None
    if len(guests) < 17:
        wedding_orig_time, wedding_orig_obj,_,_,_ = wedding_orig.solve_problem(
                                                guests, max_table_size, max_tables)
    else:
        wedding_orig_time = None
####Paste in original values until Gurobi can be validate
##    wedding_gurobi_time = wedding_time
##    wedding_gurobi_obj = wedding_obj
##    wedding_orig_gurobi_time = wedding_time
##    wedding_orig_gurobi_obj = wedding_obj
    wedding_gurobi_gen_time, wedding_gurobi_time, wedding_gurobi_obj,_,_ = wedding_gurobi.solve_problem(
                                            guests, max_table_size, max_tables)
    if len(guests) < 20:
        wedding_orig_gurobi_time, wedding_orig_gurobi_obj,_,_,_ = wedding_orig_gurobi.solve_problem(
                                                guests, max_table_size, max_tables)
    else:
        wedding_orig_gurobi_time = None
    wedding_dip_time, wedding_dip_obj,_,_,_ = wedding_dip.solve_problem(
                                            guests, max_table_size, max_tables)
    wedding_dip_solver_time, wedding_dip_solver_obj,_,_,_ = wedding_dip_solver.solve_problem(
                                            guests, max_table_size, max_tables)
    if wedding_time == None:
        wedding_obj = wedding_dip_obj
    if wedding_orig_time == None:
        wedding_orig_obj = wedding_dip_obj
    if wedding_gurobi_time == None:
        wedding_gurobi_obj = wedding_dip_obj
    if wedding_orig_gurobi_time == None:
        wedding_orig_gurobi_obj = wedding_dip_obj

    print 'guests = ', guests
    print 'wedding_gen_time = ', wedding_time
    print 'wedding_time = ', wedding_time, round(wedding_obj)
    print 'wedding_orig_time = ', wedding_orig_time, round(wedding_orig_obj)
    print 'wedding_gurobi_gen, time = ', wedding_gurobi_gen_time
    print 'wedding_gurobi_time = ', wedding_gurobi_time, round(wedding_gurobi_obj)
    print 'wedding_orig_gurobi_time = ', wedding_orig_gurobi_time, round(wedding_orig_gurobi_obj)
    print 'wedding_dip_time = ', wedding_dip_time, round(wedding_dip_obj)
    print 'wedding_dip_solver_time = ', wedding_dip_solver_time, round(wedding_dip_solver_obj)
    
    assert (round(wedding_obj) == round(wedding_orig_obj) ==
            round(wedding_gurobi_obj) == round(wedding_orig_gurobi_obj) ==
            round(wedding_dip_obj) == round(wedding_dip_solver_obj))

    with open(OUTPUT_FILE, 'a') as out_file:
        out_file.write(','.join(map(str,
            [guests[-1], wedding_gen_time, wedding_time, wedding_orig_time, wedding_gurobi_gen_time, wedding_gurobi_time, wedding_orig_gurobi_time,
            wedding_dip_time, wedding_dip_solver_time, str(wedding_obj) + '\n'])))

